#!/bin/sh

set -e
set -x

# This is originally from ftp://ftp.andrew.cmu.edu/pub/cyrus-mail
FILE=cyrus-imapd-1.6.24

cd /usr/local/src
tar xvzf /dist/$FILE.tar.gz

cd $FILE
./configure --with-com_err
make
if ! id cyrus; then
  adduser cyrus -g mail
fi
make install

# Fix cyrus permissions. Kludge to allow direct exec of cyrus by any user.
chmod 4755 /usr/cyrus/bin/imapd
chmod 4755 /usr/cyrus/bin/pop3d
# If using dpipe, give the dpipe user access to deliver
if id dpipe >/dev/null 2>&1; then
  chgrp dpipe /usr/cyrus/bin/deliver
  chmod 4750 /usr/cyrus/bin/deliver
fi

# Create cyrus directories, conf, etc.
cat >/etc/imapd.conf <<'...EOF...'
configdirectory: /var/imap
partition-default: /var/spool/imap
sasl_pwcheck_method: pwcheck
admins: root
srvtab: /var/imap/srvtab
reject8bit: no
...EOF...

cd /var
mkdir -p imap
chown cyrus.mail imap
chmod 750 imap
cd imap
touch mailboxes
mkdir -p user quota proc log msg
chown cyrus.mail *
cd /var/spool
mkdir -p imap
chown cyrus.mail imap
chmod 750 imap
cd /var/imap
chattr +S . user quota /var/spool/imap
mkdir -p /var/pwcheck
chown cyrus /var/pwcheck
chmod 700 /var/pwcheck
