#ifndef CONF_H
#define CONF_H

#include <config.h>

#ifdef DAEMONIZE
#include <dlfcn.h>
#include "dpipe_mod.h"
#endif

#define MODULE_WHEN_BEFORE 1
#define MODULE_WHEN_AFTER 2

struct module_conf {
  char *name;
  int when;
  dbd_conf_section_t *conf;
#ifdef DAEMONIZE
  int (*process_message)(struct message *msg, void *opts);
  void *options;
#endif
  struct module_conf *next;
};

struct module_conf *read_conf(char *file);

dbd_conf_element_t *conf_find_key(dbd_conf_section_t *s,
                                  dbd_conf_element_t *v,
                                  const char *key);

extern char *dpipe_opt_domain;
extern char *dpipe_opt_inject;
extern char *dpipe_opt_inbox;

#endif /* CONF_H */
