Summary:   A message massaging mail delivery system
Name:      dpipe
Version:   0.9
Release:   1
Copyright: TBA
Group:     System Environment/Daemons
Source:    dpipe-0.9.tar.gz
BuildRoot: /var/tmp/dpipe-0.9-root/
Requires:  gpgd 

%description
The Delivery Pipe is a component of the Mithril secure email system
that uses plugins to perform arbitrary operations on messages just
before or just after final delivery.

%package mod-notification
Summary: a dpipe module for notifying users of new mail
Group:     System Environment/Daemons

%description mod-notification
The notification dpipe module can be used to notify a user at another
address that they have received mail.

%package mod-tracking-mdn
Summary: a dpipe module for sending delivery receipts
Group:     System Environment/Daemons

%description mod-tracking-mdn
The tracking-mdn dpipe module can generate a message disposition
notification as specified in RFC2298.  These are delivery receipts.

%package mod-in-reply-to
Summary: a dpipe module that sets In-Reply-To based on References
Group:     System Environment/Daemons

%description mod-in-reply-to
The in-reply-to dpipe module will set the In-Reply-To header if it
isn't set, but the same information is available in the References
header.  This allows IMAP clients to thread reliably using only the
ENVELOPE fetch attribute.

%package mod-user-exists
Summary: a dpipe module for checking for user keypair existence
Group:     System Environment/Daemons

%description mod-user-exists
The user-exists dpipe module will connect to a GPG daemon, check for the
existence of the user, and bounce the message if the user does not exist.

%prep
%setup

%build
./configure --prefix=/usr
make

%install
rm -rf "$RPM_BUILD_ROOT"
mkdir -p "$RPM_BUILD_ROOT"/etc/rc.d/init.d
make DESTDIR="$RPM_BUILD_ROOT" install
install dpipe.init "$RPM_BUILD_ROOT"/etc/rc.d/init.d
install -d "$RPM_BUILD_ROOT"/etc/mithril
install dpipe.conf.example "$RPM_BUILD_ROOT"/etc/mithril/dpipe.conf

%pre
/usr/sbin/adduser -c 'Delivery Pipe User' -s /bin/false -d / dpipe

%post
mkdir -p /var/dpipe
chown dpipe.nobody /var/dpipe
chmod 750 /var/dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc0.d/K52dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc1.d/K52dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc2.d/S52dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc3.d/S52dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc5.d/S52dpipe
ln -fvs ../init.d/dpipe.init /etc/rc.d/rc6.d/K52dpipe

%postun
/usr/sbin/userdel -r dpipe

%clean
rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-, root, root)
%config /etc/mithril/dpipe.conf
%config /var/qmail/alias/.qmail-dpipeuser
%config /etc/rc.d/init.d/dpipe.init
%doc dpipe.conf.example
/usr/sbin/dpipe
/usr/sbin/dpipe-deliver
%dir /usr/lib/dpipe

%files mod-notification
%defattr(-, root, root)
/usr/lib/dpipe/libnotification.*

%files mod-tracking-mdn
%defattr(-, root, root)
/usr/lib/dpipe/libtracking-mdn.*

%files mod-in-reply-to
%defattr(-, root, root)
/usr/lib/dpipe/libin-reply-to.*

%files mod-user-exists
%defattr(-, root, root)
/usr/lib/dpipe/libuser-exists.*
