#include <stdlib.h>

#include "dpipe_mod.h"
#include <libdbd.h>

int process_message(struct message *m, void *opts) {
  char *id, *end_id;
  const char *references;
  int len;

  if (m->mime->message->envelope->in_reply_to != NULL)
    return 0; /* already set */

  if ((references = mime_parameter_find(m->mime->message->envelope->other, "references")) == NULL)
    return 0; /* no references either */

  if (((id = strrchr(references, '<')) == NULL) ||
      ((end_id = strchr(id, '>')) == NULL))
    return 0; /* not much of a message-id */

  len = end_id - id;
  id = strncpy(dbd_malloc(len+1), id, len);
  id[len] = 0;

  m->mime->message->envelope->in_reply_to = id;

  return 0;
}

