#ifndef _NOTIFICATION_H_
#define _NOTIFICATION_H_

#define QMAIL_INJECT_PATH "/var/qmail/bin/qmail-inject"

#ifndef MSG_URL
  #define MSG_URL   "https://" DOMAIN "/perl/messageurl.cgi"
#endif

#ifndef LOGIN_URL
  #define LOGIN_URL "https://" DOMAIN "/"
#endif		

#ifndef INBOX
  #define INBOX "INBOX"
#endif

struct ntf_conf {
  char *inject;
  char *msg_url, *login_url;
  char *domain;
  char *inbox;
};

typedef enum {
  NTF_TYPE_EMAIL = 0,
  NTF_TYPE_MAX
} ntf_type;

typedef void (*ntf_dispatch_t)(struct message *, const char *, struct ntf_conf *);

struct ntf_t {
  int n_items;
  struct {
    ntf_type type;
    char *target;
  } *items;
};

typedef int (*ntf_condition_t)(struct message *, struct ntf_conf *);

static int ntf_cond_normal(struct message *m, struct ntf_conf *);

static void ntf_dispatch_email(struct message *m, const char *addr, struct ntf_conf *opts);

#endif /* !_NOTIFICATION_H_ */
