#include "readmsg.h"

#include <libdbd.h>

#include <ctype.h>
#include <stdlib.h>

struct message *readmsg(FILE *fp) {
  char buf[1024];
  struct message *m = NULL;
  dbd_buffer_stream bs;
  
  m = dbd_malloc(sizeof(struct message));
  m->recipient = NULL;
  m->mime = NULL;
#ifdef HAVE_USERDATA_H
  m->db = NULL;
#endif
  m->delivery_status = MESSAGE_STATUS_SUCCESS;

  dbd_buf_init(&bs);

  while (fgets(buf, sizeof (buf), fp) != NULL) {
    unsigned long len = strlen(buf);

    if (buf[len - 1] == '\n') {
      if (buf[len - 2] == '\r')
        dbd_buf_write(&bs, buf, len);
      else {
        dbd_buf_write(&bs, buf, len - 1);
        dbd_buf_write(&bs, "\r\n", 2);
      }
    } else
      dbd_buf_write(&bs, buf, len);
  }
  
  if (ferror(fp)) {
    dbd_log(LOG_ERR, "error reading message: %m\n");
    goto error;
  }

      /* don't dbd_buf_free(&bs), mimebuffer snarfed it */
  m->mime = mime_context_new_from_buf(bs.buf, bs.used);
  if (!m->mime)
    goto error;

  return m;

  error:

  if (!m->mime) dbd_buf_free(&bs);
  
  message_destroy(m);
  
  return NULL;
}

void message_destroy(struct message *m) {
  if (m) {
    if (m->mime) mime_context_destroy(m->mime);
#ifdef HAVE_USERDATA_H
    if (m->db) {
      userdata_close(m->db);
      free(m->db);
    }
#endif
    if (m->recipient) free(m->recipient);
    free(m);
  }
}
