#ifndef DAEMON_COMMANDS_H
#define DAEMON_COMMANDS_H

#include <stdio.h>

struct daemon_command {
  char *name; /* case insensitive */
  int has_args; /* Does the command have arguments? These are split
                 individually within each command function. */
  int has_auth; /* Does the command require an authenticated login? */
  void (*func)(char *, FILE *, FILE *); 
};

const struct daemon_command *daemon_find_command(const char *name);

void daemon_command_genkey(char *args, FILE *in, FILE *out);
void daemon_command_crypt(char *args, FILE *in, FILE *out);
void daemon_command_login(char *args, FILE *in, FILE *out);
void daemon_command_decrypt(char *args, FILE *in, FILE *out);
void daemon_command_clearsign(char *args, FILE *in, FILE *out);
void daemon_command_detachsign(char *args, FILE *in, FILE *out);
void daemon_command_import(char *args, FILE *in, FILE *out);
void daemon_command_addkeys(char *args, FILE *in, FILE *out);
void daemon_command_getpubkeys(char *args, FILE *in, FILE *out);
void daemon_command_listkeys(char *args, FILE *in, FILE *out);
void daemon_command_dverify(char *args, FILE *in, FILE *out);
void daemon_command_keyinfo(char *args, FILE *in, FILE *out);
void daemon_command_exists(char *args, FILE *in, FILE *out);
void daemon_command_setpass(char *args, FILE *in, FILE *out);

#endif /* DAEMON_COMMANDS_H */
