#ifndef DAEMON_KEYS_H
#define DAEMON_KEYS_H

#include "util.h"

struct daemon_keylist {
  char *buf;
  unsigned long len;
  struct daemon_keylist *next;
};

int daemon_export_keyblock_to_buffer(const char *keyblock, int secret,
		char **dest, int *destsize);
int daemon_import_keyblock_from_buffer(const char *src, int srcsize);
int daemon_list_keys(const char *keyblock, struct daemon_keylist **kl,
    unsigned *nkl, int secret);
int daemon_keyedit(int use_keyid,
    u32 keyid[2], const char *user, const char *pass);

int daemon_check_keypass(void);

#endif /* DAEMON_KEYS_H */
