#
# gnupg -- gnu privacy guard
# This is a template.  The dist target uses it to create the real file.
#
%define version 0.9.8
%define name gnupg
%define keyroot /var/spool/keyroot
Summary: GPL public key crypto
Name: %{name}
Version: %{version}
Release: 1
Copyright: GPL
Group: Applications/Cryptography
Source: ftp://ftp.gnupg.org/pub/gcrypt/%{name}-%{version}.tar.gz
URL: http://www.gnupg.org
Provides: gpg openpgp gpgd
BuildRoot: /tmp/rpmbuild_%{name}

%changelog
* Wed May 03 2000 Peff King <peff@dbd.com>
- Added gpgd to provides
- Add user gpg
- Add creation of keyroot area

* Sat May 29 1999 Fabio Coatti <cova@ferrara.linux.it>
- Some corrections in French description, thanks to 
Gal Quri <gqueri@mail.dotcom.fr>  

* Mon May 17 1999 Fabio Coatti <cova@felix.unife.it>
- Added French description, provided by 
Christophe Labouisse <labouiss@cybercable.fr>

* Thu May 06 1999 Fabio Coatti <cova@felix.unife.it> 
- Upgraded for 0.9.6 (removed gpgm)

* Tue Jan 12 1999 Fabio Coatti <cova@felix.unife.it>
- LINGUAS variable is now unset in configure to ensure that all
  languages will be built. (Thanks to Luca Olivetti <luca@luca.ddns.org>)
 
* Sat Jan 02 1999 Fabio Coatti <cova@felix.unife.it>
- Added pl language file.
- Included g10/pubring.asc in documentation files.

* Sat Dec 19 1998 Fabio Coatti <cova@felix.unife.it>
- Modified the spec file provided by Caskey L. Dickson <caskey-at-technocage.com>
- Now it can be built also by non-root. Installation has to be done as
root, gpg is suid.
- Added some changes by  Ross Golder <rossigee@bigfoot.com>
- Updates for version 0.4.5 of GnuPG (.mo files)

%description
GnuPG is a complete and free replacement for PGP. Because it does not
use IDEA or RSA it can be used without any restrictions. GnuPG is in
compliance with the OpenPGP specification (RFC2440).

%description -l it
GnuPG  un sostituto completo e gratuito per il PGP. Non utilizzando
IDEA o RSA pu essere utilizzato senza restrizioni. GnuPG  conforme
alle specifiche OpenPGP (RFC2440).

%description -l fr
GnuPG est un remplacement complet et  libre  de PGP. Comme il n'utilise
ni IDEA ni RSA il peut tre utilis sans restriction. GnuPG est conforme
 la spcification OpenPGP (RFC2440).                         

%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup

%build
if test -n "$LINGUAS"; then
 unset LINGUAS
fi    
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-direct-resolve
make

%install
make install-strip prefix=$RPM_BUILD_ROOT/usr
mkdir -p "$RPM_BUILD_ROOT"/etc/rc.d/init.d
install scripts/gpgd "$RPM_BUILD_ROOT"/etc/rc.d/init.d

%post
adduser -c "GPGd User" -d %{keyroot} gpg
mkdir -p -m 0755 %{keyroot}
for i in `seq 0 49`; do
  mkdir -pm 700 %{keyroot}/$i
  chown gpg.gpg %{keyroot}/$i
  for j in `seq 0 49`; do
    mkdir -pm 700 %{keyroot}/$i/$j
    chown gpg.gpg %{keyroot}/$i/$j
  done
done
mkdir -p -m 0755 %{keyroot}/dev
mknod -m 644 %{keyroot}/dev/random c 1 8
mknod -m 644 %{keyroot}/dev/urandom c 1 9
mkdir -p -m 0755 %{keyroot}/etc
echo "127.0.0.1 localhost" >>%{keyroot}/etc/hosts
chmod 644 %{keyroot}/etc/hosts
ln -vs ../init.d/gpgd /etc/rc.d/rc0.d/K52gpgd
ln -vs ../init.d/gpgd /etc/rc.d/rc1.d/K52gpgd
ln -vs ../init.d/gpgd /etc/rc.d/rc2.d/S52gpgd
ln -vs ../init.d/gpgd /etc/rc.d/rc3.d/S52gpgd
ln -vs ../init.d/gpgd /etc/rc.d/rc5.d/S52gpgd
ln -vs ../init.d/gpgd /etc/rc.d/rc6.d/K52gpgd

%files

%doc %attr (-,root,root) INSTALL
%doc %attr (-,root,root) AUTHORS
%doc %attr (-,root,root) COPYING
%doc %attr (-,root,root) ChangeLog
%doc %attr (-,root,root) NEWS
%doc %attr (-,root,root) README
%doc %attr (-,root,root) THANKS
%doc %attr (-,root,root) TODO   
%doc %attr (-,root,root) PROJECTS
%doc %attr (-,root,root) doc/DETAILS
%doc %attr (-,root,root) doc/FAQ
%doc %attr (-,root,root) doc/HACKING
%doc %attr (-,root,root) doc/OpenPGP
%doc %attr (-,root,root) g10/pubring.asc
%doc %attr (-,root,root) g10/OPTIONS

%attr (-,root,root) /usr/man/man1/gpg.1
%attr (4755,root,root) /usr/bin/gpg
%attr (0755,root,root) /etc/rc.d/init.d/gpgd

%attr (-,root,root) /usr/share/locale/de/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/it/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/fr/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/ru/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/es_ES/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/pt_BR/LC_MESSAGES/%{name}.mo
%attr (-,root,root) /usr/share/locale/pl/LC_MESSAGES/%{name}.mo


%attr (-,root,root) /usr/lib/%{name}
%attr (-,root,root) /usr/share/%{name}

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
