#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define HASH_DEPTH 2
#define HASH_BUCKETS 50
#define BUCKET_STRLEN 2

char *gpg_hash(const char *user) {
  int i;
  int vals[HASH_DEPTH];
  char *dir;
  char buf[BUCKET_STRLEN+2];

  memset(vals, 0, HASH_DEPTH * sizeof(int));

  for(i = strlen(user) - 1; i >= 0; i--)
    vals[i%HASH_DEPTH] += user[i];

  dir = malloc(HASH_DEPTH * (BUCKET_STRLEN + 1) 
      + strlen(user) + 1);
  dir[0] = '\0';
  for(i = 0; i < HASH_DEPTH; i++) {
    snprintf(buf, BUCKET_STRLEN+1, "%d", vals[i] % HASH_BUCKETS);
    strcat(dir, buf);
    strcat(dir, "/");
  }
  strcat(dir, user);

  return dir;
}

int main(int argc, char **argv) {
  int i;

  for(i = 1; i < argc; i++) {
    char *p = gpg_hash(argv[i]);
    puts(p);
    free(p);
  }

  return 0;
}

