Summary: Tools for using daemonized GPG
Name: gpg-tools
Version: 0.9
Release: 1
Copyright: GPL
Group: Miscellaneous/Miscellaneous
Source: gpg-tools-0.9.tar.gz
BuildRoot: /var/tmp/gpg-tools-0.9.tar.gz

%description
Tools for using daemonized GPG. See individual descriptions for more
information.

%package pwcheck
Summary: A replacement pwcheck for authenticating against key passphrases.
Group: System Environment/Daemons

%description pwcheck
This is a replacement for the pwcheck daemon that comes with cyrus imapd. It
authenticates passphrases against the users' default secret key passphrase
using the daemonized gpg.

%package adduser
Summary: A script to add users to the GPGd system
Group: Applications/System
Requires: gpg-tools-adduser

%description adduser
adduser-gpg creates the files necessary for a user to be created by GPGd,
connects to the daemon socket, and creates keys for the user.

%package hash
Summary: A program to reproduce the directory hashes of gpgd
Group: Applications/System

%description hash
gpg-hash produces the same directory hashes of gpgd, which makes it useful
for tracking/adding individual users in the filesystem.

%prep
%setup

%build
./configure --prefix=/usr
make

%install
rm -rf "$RPM_BUILD_ROOT"
mkdir -p "$RPM_BUILD_ROOT"/etc/rc.d/init.d
make DESTDIR="$RPM_BUILD_ROOT" install
install pwcheck-gpg.init "$RPM_BUILD_ROOT"/etc/rc.d/init.d/pwcheck-gpg

%pre pwcheck
/usr/sbin/groupadd pwcheck
install -d -m 1770 -o cyrus -g pwcheck /var/pwcheck

%post pwcheck
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc0.d/K48pwcheck-gpg
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc1.d/K48pwcheck-gpg
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc2.d/S52pwcheck-gpg
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc3.d/S52pwcheck-gpg
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc5.d/S52pwcheck-gpg
ln -fvs ../init.d/pwcheck-gpg /etc/rc.d/rc6.d/K48pwcheck-gpg

%preun pwcheck
rm -vf /etc/rc.d/rc?.d/[KS][0-9][0-9]pwcheck-gpg

%postun pwcheck
rm -f /var/pwcheck/pwcheck
rmdir /var/pwcheck
/usr/sbin/groupdel pwcheck

%files pwcheck
%defattr(-, root, root)
/usr/sbin/pwcheck-gpg
/etc/rc.d/init.d/pwcheck-gpg

%files adduser
%defattr(-, root, root)
/usr/sbin/adduser-gpg

%files hash
%defattr(-, root, root)
/usr/sbin/gpg-hash
