#include <stdlib.h>
#include <string.h>
#include <libdbd.h>

#include "imapproxy.h"
#include "imap_cmd.h"
#include "imap_resp.h"

/* APPEND . . . {<len>} <CRLF> <msg> <CRLF>*/
int cmd_APPEND(imap_session *sess, char *tag, char *cmd) {
  size_t len, i = 0;
  char *p, *q;
  
  if (((p = strrchr(cmd, '{')) == NULL) ||
      ((q = strrchr(p, '}')) == NULL)) {
    dbd_log(LOG_ERR, "WARNING - couldn't parse prefix quoted string from APPEND command: %s %s", tag, cmd);
    client_writeresp(sess, tag, "BAD Invalid literal in Append command");
    
    return 1;
  }

  server_writecmd(sess, tag, cmd);

  len = atoi(p + 1);
  if (q[-1] != '+') { /* {nn+} means not to wait for prompt */
    do
      server_handle_response(sess);
        while ((sess->last_status != IMAP_STATUS_GO_AHEAD) &&
               (strcmp(tag, sess->last_tag) != 0));
    
    if (strcmp(tag, sess->last_tag) == 0)
      return 1;
  }

  while (i < (len+2)) {
    if ((p = client_getline(sess)) == NULL) return 0;
    i += strlen(p) + 2; /* crlf */
    server_writeline(sess, p);
  }

#if 0
  if ((p = client_getline(sess)) == NULL) return 0;
  server_writeline(sess, p); /* trailing crlf */
#endif

  if (i != (len+2))
    dbd_log(LOG_ERR, "WARNING - wrote %d+%d bytes in APPEND command",
           len, i - (len+2));
  
  return 1;
}
