#ifndef IMAP_SEQ_H
#define IMAP_SEQ_H

typedef struct _imap_sequence {
  unsigned long first, last;
  struct _imap_sequence *next;
} imap_sequence;

extern imap_sequence *imap_sequence_new(void);
extern char *imap_sequence_new_from_string(char *cmd, imap_sequence **out);

extern imap_sequence *imap_sequence_remove(imap_sequence *seq,
                                           imap_sequence *new);
extern imap_sequence *imap_sequence_remove_one(imap_sequence *seq,
                                               unsigned long message);
extern imap_sequence *imap_sequence_add(imap_sequence *seq,
                                        imap_sequence *new);
imap_sequence *imap_sequence_add_one(imap_sequence *seq,
                                     unsigned long message);

extern int imap_sequence_has_message(imap_sequence *seq,
                                     unsigned long message);

extern void imap_sequence_destroy(imap_sequence *seq);

extern void imap_sequence_to_buffer_stream(dbd_buffer_stream *bs,
                                           imap_sequence *seq);

#endif /* !IMAP_SEQ_H */
