<?php
if( !defined( 'PACKAGE_invoke' ) )
{
 define( 'PACKAGE_invoke', 1 );

 class invoke
 {
	// Class parameters
	var $host = ""; // socket host
	var $port = ""; // socket port
	var $timeout = 30;  // how long to try to connect before fracking out

	// Config file name and handle
	var $cfg_file = "/etc/keyconf";
	var $cfg_handle = 0;

	// Socket handle
	var $socket = 0;

	// Session control
	var $login = "";
	var $passwd = "";

	// Error handling
	var $errno = 0;
	var $errstr = '';


	// Constructor
	function invoke( $result )
	{
		if( !$this->cfg_handle = fopen( $this->cfg_file, "r" ) )
			$result = "Error: Failed to open config file $this->cfg_file";
		else if( !$this->host = chop( fgets( $this->cfg_handle, 4096 ) ) )
			$result = "Error: Could not read hostname!";
		else if( !$this->port = chop( fgets( $this->cfg_handle, 4096 ) ) )
			$result = "Error: Could not read port!";
		else if( !$this->timeout = chop( fgets( $this->cfg_handle, 4096 ) ) )
			$result = "Error: Could not read timeout!";
		else
			return true;
		return false;
	} // constructor

	// Open a connection and login
	function login( $login, $passwd, $result="" )
	{
		if( !$this->socket = fsockopen( $this->host, $this->port, &$this->errno, &$this->errstr, $this->timeout ) )
		{
			$result = "Error $this->errno: $this->errstr<br>"
				 ."host was $this->host, port was $this->port";
			return false;
		}
		else
		{
			fputs( $this->socket, "login^$login^$passwd\n" );
			$result = fgets( $this->socket, 1025 );
			$result = substr( fgets( $this->socket, 1025 ), 0, 2 );
			if( $result != "OK" )
			{
				$result = "Login failed!  Check username and password!";
				return false;
			}
			else
				return true;
		}
	} // login( )

	// Logout and close the connection
	function logout( $result="" )
	{
		fputs( $this->socket, "quit\n" );
		$result = fgets( $this->socket, 1025 );
		@fclose( $this->socket );
		if( substr( $result, 0, 2 ) != "OK" )
		{
			$result = "Could not logout!  Server said: $result";
			return false;
		}
		else
			return true;
	}

	// Change password
	function changepwd( $passwd, $result="" )
	{
		fputs( $this->socket, "setpass^$passwd\n" );
		$result = substr( fgets( $this->socket, 1025 ), 0, 2 );
		if( $result != "OK" )
		{
			$result = "Error: Could not change password!";
			return false;
		}
		else
			return true;
	}

	// Display keyring
	function keyring( $num, $keytype, $keysize, $keyalgo, $keyid, $keydate, $keyowner )
  	{
		fputs( $this->socket, "listkeys\n" );
		$num = substr( fgets( $this->socket, 1025 ), 3 );
		for( $i = 0; $i < $num; $i++ )
		{
			$key_info_length = substr( fgets( $this->socket, 1025 ), 3 );
			$key_info = fgets( $this->socket, $key_info_length + 1 );
			$key_info_read = strlen( $key_info );
			while( $key_info_length - $key_info_read > 1 )
			{
				$line = fgets( $this->socket, $key_info_length - $key_info_read );
				$key_info .= $line;
				$key_info_read += strlen( $line );
			}
			$key_info_list = split( " ", str_replace( "\n", " ", $key_info ) );
			$keytype[$i] = $key_info_list[0];
			$keysize[$i] = $key_info_list[1];
			$keyalgo[$i] = $key_info_list[2];
			$keyid[$i] = $key_info_list[3] . $key_info_list[4];
			$keydate[$i] = $key_info_list[5];
			$keyowner[$i] = $key_info_list[6];
			for( $k = 7; $key_info_list[$k] != ""; $k++ )
			{
				$keyowner[$i] .= $key_info_list[$k];
			}
		}
	}

	// Add a new key
	function addkey( $key_block, $result="" )
	{
		// Add the key to the keyring
		$keysize = strlen( $key_block );
		fputs( $this->socket, "addkeys^$keysize\n" );
		if( fgets( $this->socket, 1025 ) != "OK^GOAHEAD\n" )
		{
			$result = "Error! Cannot add key!";
			return false;
		}
		fputs( $this->socket, $key_block );
		$result = fgets( $this->socket, 1025 );
		return true;
	}
 }
}
?>
