#ifndef DBDCONF_H
#define DBDCONF_H

#include <stdio.h>

typedef struct _dbd_conf_element_t dbd_conf_element_t;
struct _dbd_conf_element_t {
  char *key;
  char *value;
  struct _dbd_conf_element_t *next;
};

typedef struct _dbd_conf_section_t dbd_conf_section_t;
struct _dbd_conf_section_t {
  char *name;
  unsigned size;
  dbd_conf_element_t *elements;
  struct _dbd_conf_section_t *next;
};

typedef struct _dbd_conf_t dbd_conf_t;
struct _dbd_conf_t {
  char *filename;
  unsigned size;
  dbd_conf_section_t *sections;
};

dbd_conf_t *dbd_conf_parse_file(const char *filename);
dbd_conf_t *dbd_conf_parse_filehandle(const char *filename, FILE *fp);

void dbd_conf_destroy(dbd_conf_t *c);

const char *dbd_conf_find(const dbd_conf_t *c, const char *section, 
    const char *key);
dbd_conf_section_t *dbd_conf_find_section(const dbd_conf_t *c,
    const char *section);
const char *dbd_conf_section_find(const dbd_conf_section_t *c, const char *key);

#endif /* DBDCONF_H */
