#ifndef DBDLOG_H
#define DBDLOG_H

#include <syslog.h>
#include <string.h>
#include <errno.h>

void dbd_log_func(int severity, const char *file, int line, 
    const char *format, ...);

#define dbd_log(s, fmt, args...) dbd_log_func(s, __FILE__, __LINE__, \
    fmt, ## args)
#define dbd_error(s, fmt, args...) dbd_log_func(s, __FILE__, __LINE__, \
    fmt ": %s" , ## args, strerror(errno))

#endif /* DBDLOG_H */
