#ifndef DBDMISC_H
#define DBDMISC_H

#include <stddef.h>
#include <sys/types.h>
#include <stdio.h>

void *dbd_malloc(size_t s);
void *dbd_realloc(void *p, size_t s);
char *dbd_strdup(const char *s);
char *dbd_strndup(const char *s, size_t n);
char *dbd_memstr(const char*s, size_t n);
pid_t dbd_fork();

typedef struct {
	char **v;
	int len;
} dbd_vec_t;

int dbd_chomp(char *str);
int dbd_split(const char *delim, char *str, int max, char **output, 
		int allownull);

char *dbd_getline(char *oldbuf, unsigned long *buflen, FILE *fp);

dbd_vec_t dbd_split_a(const char *delim, const char *str);
dbd_vec_t dbd_split_am(const char *delim, const char *str, char metachar);
void dbd_vec_free(dbd_vec_t v);
dbd_vec_t dbd_vec_cat(dbd_vec_t a, dbd_vec_t b);
dbd_vec_t *dbd_vec_copy(const dbd_vec_t *v);

#define dbd_vecfree(v) dbd_vec_free(v)
#define dbd_veccat(a,b) dbd_vec_cat(a,b)

#endif /* DBDMISC_H */
