#ifndef DBDNET_H
#define DBDNET_H

#include <netinet/in.h>

int dbd_resolve(const char *host, struct in_addr *saddr);
void dbd_reverse_lookup(char *host, int len, struct in_addr saddr);

int dbd_iconnect(const char *host, unsigned short int port);
int dbd_ilisten(unsigned short int port);
int dbd_iaccept(char *host, int len, int fd);

int dbd_uconnect(const char *file);
int dbd_ulisten(const char *file, int remove_stale);

/* This makes a socket writeable only be UID and connectable only
 * by members of gid */
int dbd_protect_socket(const char *file, uid_t uid, gid_t gid);

typedef enum {
  DBD_CONN_UNKNOWN,
  DBD_CONN_UNIX,
  DBD_CONN_INET
} dbd_conn_type_t;

#define DBD_NET_PATH_MAX 128

typedef struct {
  dbd_conn_type_t type;
  char path[DBD_NET_PATH_MAX];
  unsigned short port;
} dbd_conn_t;

int dbd_conn_set_inet_path(dbd_conn_t *c, const char *h, unsigned short path);
int dbd_conn_set_unix_path(dbd_conn_t *c, const char *path);
int dbd_conn_connect(const dbd_conn_t *c);

#endif /* DBDNET_H */
