#ifndef LIBFIXUP_MIME_H
#define LIBFIXUP_MIME_H

#include <libmime.h>

struct _FixupContext;
typedef struct _FixupContext FixupContext;

MimeContext *fixup_mime(FixupContext *fc, MimeContext *mime);
MimeMessage *fixup_message(FixupContext *fc, MimeMessage *m,
    dbd_buffer_stream *cs_plain,
    dbd_buffer_stream *cs_html,
    dbd_buffer_stream *cs_gpgd,
    dbd_buffer_stream *part);
MimeBody *fixup_body(FixupContext *fc, MimeBody *b,
    dbd_buffer_stream *cs_plain,
    dbd_buffer_stream *cs_html,
    dbd_buffer_stream *cs_gpgd,
    dbd_buffer_stream *part);

FixupContext *fixup_context_new(dbd_conf_section_t *conf);

void fixup_context_set_user(FixupContext *fc, const char *user);
void fixup_context_set_folder(FixupContext *fc, const char *folder);

MimeCrypt *fixup_context_get_mime_crypt(FixupContext *fc);

#endif /* LIBFIXUP_MIME_H */
