#ifndef SPEWERY_H
#define SPEWERY_H

typedef struct _spew_block {
  enum {
    SPEW_TEXT,
    SPEW_VAR,
  } type;

  union {
    char *text;

    struct {
      char *name;
      char *dfault;
    } var;
  } data;

  struct _spew_block *next;
} spew_block;

typedef struct _spew_dict_entry {
  char *name;
  char *value;
} spew_dict_entry;

typedef struct _spew_dict {
  spew_dict_entry **entries;

  int size;
} spew_dict;

extern spew_block *spew_new_from_buffer(char *buf);
extern spew_dict *spew_dict_new(void);
extern void spew_dict_add_vars(spew_dict *dict, ...);
extern void spew_to_buffer(dbd_buffer_stream *bs,
                           spew_block *spew, spew_dict *dict);
extern void spew_dict_destroy(spew_dict *dict);
extern void spew_destroy(spew_block *spew);

#endif
