#ifndef MIMEADDRESS_H
#define MIMEADDRESS_H

#include <mimeparameter.h>
#include <libdbd.h>

typedef struct _MimeAddress MimeAddress;
struct _MimeAddress {
  char *name;
  char *mailbox;
  char *host;
  char *sroute;
  struct _MimeAddress *next;
};

MimeAddress *mime_address_new();
MimeAddress *mime_address_copy(const MimeAddress *a);

int mime_address_new_from_string(const char *s, MimeAddress **list);

void mime_address_to_buffer_stream(const MimeAddress *a, 
    dbd_buffer_stream *bs);

/* Take one or more address lists and form a vector consisting of all 
 * addresses concatened into one list in user@host format */
dbd_vec_t *mime_address_to_vector(const MimeAddress *a, ...);

void mime_address_destroy_list(MimeAddress *a);


#endif /* MIMEADDRESS_H */
