#ifndef MIMEBOUNDARY_H
#define MIMEBOUNDARY_H

#include <libdbd.h>

#define MIME_BOUNDARY_MAX 64

/* Generate a new boundary. This tries its best to be unique without
 * actually checking against the contents (thus there is a small but
 * nonzero collision possibility */
char *mime_boundary_generate(char *buf);

/* Find the boundary located in a buffer. 
 * Returns -1 in case of end of buffer
 * Returns 0 in case the delimiter found is the closing delimiter
 * Returns 1 otherwise */
int mime_boundary_find_in_buf(const char *buf, unsigned long len,
    const char *boundary, const char **result_begin, 
    const char **result_end);

#define mime_boundary_to_buffer_stream(b, bs) \
  dbd_buf_puts_multiple(bs, "\r\n--", boundary, "\r\n", NULL);
#define mime_boundary_final_to_buffer_stream(b, bs) \
  dbd_buf_puts_multiple(bs, "\r\n--", boundary, "--\r\n", NULL);

#endif /* MIMEBOUNDARY_H */
