#ifndef MIMEBUFFER_H
#define MIMEBUFFER_H

typedef struct _MimeSubBuffer MimeSubBuffer;
struct _MimeSubBuffer {
  char *buf;
  unsigned long len;
  struct _MimeSubBuffer *next;
};

typedef struct _MimeBuffer MimeBuffer;
struct _MimeBuffer {
  char *buf;
  unsigned long len;
  MimeSubBuffer *sub;
};

MimeBuffer *mime_buffer_new_with_value(char *buf, unsigned long len);
MimeBuffer *mime_buffer_copy(const MimeBuffer *old);

void mime_buffer_destroy(MimeBuffer *m);
void mime_buffer_attach_subbuffer(MimeBuffer *m, char *buf, unsigned long len);

const char *mime_buffer_align(const MimeBuffer *a, const MimeBuffer *b, 
    const char *bp);

#endif /* MIMEBUFFER_H */
