#include <mimedefaults.h>

#include <libdbd.h>

#include <stdlib.h>


#define make_default_func(token, def) \
  static int default_##token##_heap = 0;\
  void mime_default_set_##token(const char *s) {\
    if(default_##token##_heap) \
      free(mime_default_##token);\
    mime_default_##token = dbd_strdup(s);\
    default_##token##_heap = 1;\
  }\
char *mime_default_##token = def

make_default_func(subject, "No subject");
make_default_func(host, "localhost");
make_default_func(nouser_address, "nouser: ;");
make_default_func(mime_prologue, 
    "This is a MIME message. If you're seeing this, your mail reader\r\n"
    "probably does not support MIME-formatted messages.  Send mail to\r\n"
    "mime@docserver.cac.washington.edu for more info.\r\n");
make_default_func(mime_epilogue, "");
make_default_func(mailbox, "");
make_default_func(mailer_name, "Mithril");
make_default_func(mime_types, "/etc/mime.types");

