#ifndef MIMEENVELOPE_H
#define MIMEENVELOPE_H

#include <mimeaddress.h>
#include <mimeparameter.h>
#include <libdbd.h>

typedef struct _MimeEnvelope MimeEnvelope;
struct _MimeEnvelope {
  MimeAddress *from;
  MimeAddress *to;
  MimeAddress *cc;
  MimeAddress *sender;
  MimeAddress *replyto;
  MimeAddress *return_path;
  MimeAddress *disposition_notification_to;

  char *subject;
  char *date;
  char *message_id;
  char *in_reply_to;

  MimeParameter *other;
};

MimeEnvelope *mime_envelope_new_from_buf(const char *buf, unsigned long len);

MimeEnvelope *mime_envelope_new();

MimeEnvelope *mime_envelope_copy(MimeEnvelope *old);

void mime_envelope_destroy(MimeEnvelope *e);

int mime_envelope_to_buffer_stream(const MimeEnvelope *e, 
    dbd_buffer_stream *bs);

#endif /* MIMEENVELOPE_H */
