#ifndef MIMEPGP_H
#define MIMEPGP_H

#include <mimebody.h>

struct _MimeCrypt;

/* Take a body structure and put it inside a PGP-MIME encryption structure.
 * The actual encryption is not done until the message is converted to an
 * actual buffer. */
MimeBody *mime_pgp_encrypt_body(MimeBody *b, const MimeEnvelope *e, 
    const dbd_vec_t *recipients);

/* Take a body structure and put it inside a PGP-MIME signature structure.
 * The actual signature is not done until the message is converted to an
 * actual buffer. */
MimeBody *mime_pgp_sign_body(MimeBody *b);

int mime_pgp_encrypted_body_to_buffer_stream(const MimeBody *b, 
    dbd_buffer_stream *bs, struct _MimeCrypt *cc, const char *boundary);
int mime_pgp_signed_body_to_buffer_stream(const MimeBody *b, 
    dbd_buffer_stream *bs, struct _MimeCrypt *cc, const char *boundary);

void mime_pgp_encrypted_body_parse(MimeBody *b, struct _MimeCrypt *cc);
void mime_pgp_signed_body_parse(MimeBody *b, struct _MimeCrypt *cc);

MimeBody *mime_pgp_flatten_encrypted(MimeBody *b);

#endif /* MIMEPGP_H */
