#ifndef MIMERFC822_H
#define MIMERFC822_H

#include <mimeparameter.h>
#include <mimeaddress.h>

#include <time.h>
#include <libdbd.h>

const char *mime_rfc822_parse_word(const char *s, const char *delim);
unsigned long mime_rfc822_parse_line(const char *s, unsigned long len, 
    MimeParameter **param);

const char *mime_rfc822_parse_address(MimeAddress **head, MimeAddress **tail, 
    const char *s);

const char *mime_rfc822_skip_whitespace(const char *p);
const char *mime_rfc822_skip_comment(const char *p);

char *mime_rfc822_unquote(const char *s, unsigned long len);
void mime_rfc822_quote_to_buffer_stream(const char *s, dbd_buffer_stream *bs);

time_t mime_rfc822_parse_date(const char *date);
void mime_rfc822_date_to_buffer_stream(time_t date, dbd_buffer_stream *bs);

char *mime_rfc822_messageid_generate();

long mime_rfc822_tm_to_long(struct tm *tm, int tz);

#endif /* MIMERFC822_H */
