#include <mimesignature.h>

#include <libdbd.h>

#include <stdlib.h>

MimeSignature *mime_signature_new_with_value(int status, 
    unsigned long timestamp, const char *keyid, const char *name) {
  MimeSignature *ms;

  ms = dbd_malloc(sizeof(MimeSignature));

  ms->status = status;
  ms->timestamp = timestamp;
  ms->keyid = keyid ? dbd_strdup(keyid) : NULL;
  ms->name = name ? dbd_strdup(name) : NULL;

  ms->next = NULL;

  return ms;
}

MimeSignature *mime_signature_copy(const MimeSignature *old) {
  MimeSignature *m;

  if(!old)
    return NULL;

  m = dbd_malloc(sizeof(MimeSignature));

  m->status = old->status;
  m->timestamp = old->timestamp;

  m->keyid = old->keyid ? dbd_strdup(old->keyid) : NULL;
  m->name = old->name ? dbd_strdup(old->name) : NULL;

  m->next = mime_signature_copy(old->next);

  return m;
}

void mime_signature_destroy_list(MimeSignature *ms) {
  if(ms->keyid)
    free(ms->keyid);
  if(ms->name)
    free(ms->name);

  if(ms->next)
    mime_signature_destroy_list(ms->next);

  free(ms);
}



