#include <crypt-client.h>
#include <libdbd.h>
#include <mimecontext.h>

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char **argv) {
  dbd_buffer_stream bs;
  MimeContext *mc;
  char *data;
  unsigned long datalen;
  MimeCrypt *mime_crypt;
  CryptContext *cc;

  if(argc < 3) {
    printf("Require login and passphrase for crypt server on command line.\n");
    printf("Halting...\n");
    return 1;
  }

  cc = crypt_context_new();
  if(crypt_login(cc, argv[1], argv[2]) < 0) {
    printf("failed crypt_login: %s\n", crypt_strerror(cc));
    return 1;
  }

  mime_crypt = mime_crypt_new();
  mime_crypt_associate_pgp(mime_crypt, cc);

  dbd_buf_init(&bs);
  while(1) {
    char buf[2048];
    int result;

    result = fread(buf, 1, 2048, stdin);
    if(!result)
      break;
    dbd_buf_write(&bs, buf, result);
  }

  mc = mime_context_new_from_buf(bs.buf, bs.used);

  mime_context_pgp_encrypt(mc);

  data = mime_context_to_buffer(mc, &datalen, mime_crypt);
  if(!data)
    printf("Some sort of error or something.\n");
  else
    write(1, data, datalen);

  mime_context_destroy(mc);
  mime_crypt_destroy(mime_crypt);
  crypt_context_destroy(cc);

  return 0;
}
