#include <stdio.h>
#include <unistd.h>

#include <libdbd.h>

#include "libmime.h"

int main(int argc, char **argv) {
  dbd_buffer_stream bs;
  MimeContext *mc;
  MimeBody *b;

  char *buf;
  unsigned long len;

  dbd_buf_init(&bs);
  while(1) {
    char buf[2048];
    int result;

    result = fread(buf, 1, 2048, stdin);
    if(!result)
      break;
    dbd_buf_write(&bs, buf, result);
  }

  mc = mime_context_new_from_buf(bs.buf, bs.used);

  b = mime_body_new();
  b->type = mime_type_new_with_value(MIME_TYPE_MESSAGE, "RFC822");
  b->child.msg = mc->message;

  mc->message = mime_message_new_blank();
  mc->message->body = b;
  mc->message->envelope = mime_envelope_new();

  if(--argc > 0)
    mime_address_new_from_string(*++argv, &mc->message->envelope->from);
  if(--argc > 0)
    mime_address_new_from_string(*++argv, &mc->message->envelope->to);

  buf = mime_context_to_buffer(mc, &len, NULL);
  if(!buf)
    fprintf(stderr, "error in converting to buffer");
  else
    write(1, buf, len);

  mime_context_destroy(mc);
  return 0;
}
