#!/bin/sh -x

mysql -u ${dba:-dba} -p <<EOF
    create database pkdb;
    use pkdb;
    create table db_ids2keys (
	db_id int not null auto_increment,
	data text not null,
	fingerprint char(40) not null,
	mod timestamp,
	sync timestamp default 0,
	unique key (db_id)
    );

    create table emails2db_ids (
	email varchar(255) not null,
	fullname varchar(255),
	db_id int not null,
	new bool default 1,
	index (email)
    );

    /* The 8 hexadecimal digits are converted and stored as a 32-bit integer. */
    create table short_key_id2db_ids (
	key_id int unsigned not null,
	db_id int not null,
	index (key_id)
    );

    /* The 16 hexadecimal digits are converted and stored as two 
       32-bit integers. */
    create table long_key_id2db_ids (
	lkey_id int unsigned not null,
	hkey_id int unsigned not null,
	db_id int not null,
	index (lkey_id, hkey_id)
    );

    create table update_timestamps (
	db_id int not null,
	client varchar(255),
	ts timestamp,
	index (ts)
    );

    grant select on pkdb.* to pk_server@localhost;
    grant select,insert,update on pkdb.* to pk_admin@localhost;

EOF
