#include "command.h"
#include "popsession.h"

#include <string.h>

#include <libdbd.h>

int cmd_user(PopSession *pop, char *line) {
  if(pop_session_server_puts(pop, line) < 0)
    return -1;

  dbd_chomp(line);
  pop_session_set_user(pop, line + 5);

  return 0;
}

int cmd_pass(PopSession *pop, char *line) {
  if(pop_session_server_puts(pop, line) < 0)
    return -1;

  dbd_chomp(line);
  pop_session_set_pass(pop, line + 5);

  return 0;
}

int cmd_retr(PopSession *pop, char *line) {
  if(pop_session_server_puts(pop, line) < 0)
    return -1;

  pop_session_set_state(pop, POP_STATE_RETR_WAIT);

  return 0;
}

#define CALLBACK_ENTRY(a) { #a, sizeof(#a) - 1, cmd_##a }

static const struct {
  const char *name;
  int len;
  int (*f)(PopSession *, char *);
} callback_table[] = {
  CALLBACK_ENTRY(user),
  CALLBACK_ENTRY(pass),
  CALLBACK_ENTRY(retr)
};
static const int callback_table_size = sizeof(callback_table) 
  / sizeof(*callback_table);

CommandCallback command_find(const char *line) {
  int i;

  for(i = 0; i < callback_table_size; i++)
    if(!strncasecmp(callback_table[i].name, line, callback_table[i].len))
      return callback_table[i].f;
  return NULL;
}

