#include <libdbd.h>

#include "popproxy.h"
#include "popsession.h"

#include <openssl/ssl.h>
#include <openssl/err.h>

#define POPPROXY_CONFIGFILE "/etc/mithril/popproxy.conf"

int main(int argc, char **argv) {
  dbd_conf_t *conf;
  PopSession *pop;

  dbd_opt_set_log_identity("popproxy");
  SSL_library_init();

  if(argc >= 2)
    conf = dbd_conf_parse_file(argv[1]);
  else
    conf = dbd_conf_parse_file(POPPROXY_CONFIGFILE);
  pop = pop_session_new(conf);
  dbd_conf_destroy(conf);

  /* Client will be preconnected on stdin */
  pop_session_set_client(pop, 0);

  if(popproxy(pop) < 0)
    return 1;
  return 0;
}
