#include "popproxy.h"
#include "command.h"

#include <string.h>

#include <libdbd.h>

static int client_input(PopSession *pop, char *line) {
  CommandCallback cc = command_find(line);
 
  if(!cc)
    return pop_session_server_puts(pop, line);
  else
    return cc(pop, line);
}

static int server_input(PopSession *pop, char *line) {
  switch(pop_session_get_state(pop)) {
    case POP_STATE_NORMAL:
      return pop_session_client_puts(pop, line);
    case POP_STATE_RETR_WAIT:
      if(line[0] == '+')
        pop_session_message_new(pop);
      else
        pop_session_set_state(pop, POP_STATE_NORMAL);
      return pop_session_client_puts(pop, line);
    case POP_STATE_MSG_WAIT:
      if(line[0] == '.') {
        line++;
        if(line[0] == '\015')
          return pop_session_message_send(pop);
      }
      pop_session_message_append(pop, line);
      return 0;
    default:
      dbd_log(LOG_ERR, "Weird POP session state. Barfing.");
      return -1;
  }
}

int popproxy(PopSession *pop) {
  if(pop_session_open_remote(pop) < 0)
    return -1;

  return pop_session_io_callback(pop, client_input, server_input);
}
