#ifndef POPSESSION_H
#define POPSESSION_H

struct _PopSession;
typedef struct _PopSession PopSession;

typedef enum {
  POP_STATE_NORMAL,
  POP_STATE_RETR_WAIT,
  POP_STATE_MSG_WAIT
} PopState;

typedef int (*PopIOCallback)(PopSession *, char *);

PopSession *pop_session_new();

void pop_session_set_client(PopSession *pop, int fd);
void pop_session_set_remote(PopSession *pop, const char *host, int port);
void pop_session_set_user(PopSession *pop, const char *user);
void pop_session_set_state(PopSession *pop, PopState state);
void pop_session_message_new(PopSession *pop);
void pop_session_message_append(PopSession *pop, const char *line);

int pop_session_set_pass(PopSession *pop, const char *pass);
int pop_session_open_remote(PopSession *pop);
int pop_session_io_callback(PopSession *pop, PopIOCallback client,
    PopIOCallback server);
int pop_session_client_write(PopSession *pop, const char *buf, int len);
int pop_session_server_write(PopSession *pop, const char *buf, int len);
int pop_session_client_puts(PopSession *pop, const char *s);
int pop_session_server_puts(PopSession *pop, const char *s);
int pop_session_message_send(PopSession *pop);

PopState pop_session_get_state(PopSession *pop);

void pop_session_close(PopSession *pop);
void pop_session_destroy(PopSession *pop);

#endif /* POPSESSION_H */
