#include <libdbd.h>
#include <openssl/bio.h>
#include <openssl/err.h>

int BIO_getline(BIO *bio, char **buf, int *buflen) {
  int len = 0, i;

  do {
    while ((len+1) >= *buflen) {
      if (*buflen < 1024)
        *buflen = 1024;
      else if (*buflen < 1024*1024)
        *buflen += *buflen;
      else
        *buflen += 1024*1024;
      if ((*buf = dbd_realloc(*buf, *buflen)) == NULL) {
        *buflen = 0;
        return -1;
      }
    }
    i = BIO_gets(bio, *buf+len, *buflen+1-len);
    if (i < 0)
      return -1;
    if (i == 0) {
      if (len) /* at this point we should have everything from the buffer */
        BIO_set_buffer_read_data(bio, *buf, len);
      return 0;
    }
    len += i;
  } while ((*buf)[len-1] != '\n');

  return len;
}

      
