#ifndef COMMANDS_H
#define COMMANDS_H

typedef struct _sc_command_handler {
  char *command;
  int len;
  int (*handler)();
  int clear_queue;   /* clear all pending responses prior to this command */
  int tls_required;  /* if tls is required and this is set, deny command */
} sc_command_handler;

typedef struct _sc_command_pending {
  char *command;
  int (*handler)();
  void *data;
  struct _sc_command_pending *next;
} sc_command_pending;

extern int command_handle(smtpcrypt *sc);

extern void command_pending_add(smtpcrypt *sc, char *cmd, int (*proc)(),
                                void *data);
extern void command_pending_complete(smtpcrypt *sc);

#endif /* COMMANDS_H */
